#ifndef __MY_WRAPPERS_H__
#define __MY_WRAPPERS_H__

#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>
#include "cs537.h"

typedef struct timeval timeval_t;
typedef struct timezone timezone_t;

typedef struct __sthread_t
{	pthread_t thread;
	int thread_id;
  	int thread_count;
  	int static_count;
  	int dynamic_count;
} sthread_t;

typedef struct __request_t
{	int connfd;
	int trd_at_arrival;
	int age;
	int size;
	timeval_t arrival_time;
	timeval_t dispatch_time;
	timeval_t read_time;
	timeval_t completion_time;
	
	//file info for SFF
	int is_static;
	char filename[MAXLINE], cgiargs[MAXLINE];
} request_t;

void Gettimeofday(timeval_t *tv, timezone_t *tz);
void *Malloc(size_t size);
void Pthread_create(pthread_t *thread, pthread_attr_t *attr, void *(*start_routine)(void*), void *arg);
void Pthread_detach(pthread_t thread);
void Pthread_mutex_lock(pthread_mutex_t  *mutex);
void Pthread_mutex_unlock(pthread_mutex_t  *mutex);
void Pthread_cond_wait(pthread_cond_t *cond, pthread_mutex_t *mutex);
void Pthread_cond_signal(pthread_cond_t *cond);
void Pthread_mutex_init(pthread_mutex_t  *mutex,  const pthread_mutexattr_t *mutexattr);
void Pthread_cond_init(pthread_cond_t *cond, pthread_condattr_t *cond_attr);

#endif
